/*

enum AuthStatus { authenticate, logout }

class UserUpdateStatusEvent {
  final AuthStatus status;

  UserUpdateStatusEvent(this.status);
}

class Sender {
  static final EventBus eventBus = EventBus();
  static fire<T>(T event) {
    eventBus.fire(event);
  }
}

abstract class ReactiveReceiver<T> {
  Stream<T> _stream;
  StreamSubscription<T> sub;

  ReactiveReceiver() : _stream = Sender.eventBus.on<T>() {
    sub = _stream.listen(on);
  }

  void on(T event);
}

class RxReceiverProperty<T> extends StreamView<T> {
  RxReceiverProperty() : super(Sender.eventBus.on<T>());
}

class RxCounter {
  final test = RxReceiverProperty<UserUpdateStatusEvent>();

  RxCounter() {
    test.listen((value) {});
  }
}

class ReactiveAuth extends ReactiveReceiver<UserUpdateStatusEvent> {
  @override
  void on(UserUpdateStatusEvent event) {
    switch (event.status) {
      case AuthStatus.authenticate:
        // to so
        break;
      default:
    }
  }
}

class Login {
  void signIngWithCredentiasl() async {
    // Realiza o login
    await Future.delayed(Duration.zero);
    Sender.fire(UserUpdateStatusEvent(AuthStatus.authenticate));
  }
}
*/
